#include <windows.h>
#include "ddemlcl.h"
#include "ddemlcf.h"


LRESULT WINAPI WndProc( HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam );

char const szClassName[]   = "DDEMLCLIENT";  //  
char const szWindowTitle[] = "DDEML Client"; //  

//  
HWND hWnd;
HINSTANCE hInst;
HCONV hConv = NULL;


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpszCmdParam, int nCmdShow)

{ WNDCLASS WndClass;   //   
  MSG Msg;             //  ""

  // ,       
  if (FindWindow(szClassName,szWindowTitle)) return false;

  hInst=hInstance; //    

  /*    */
  WndClass.style = CS_HREDRAW | CS_VREDRAW; //  
  WndClass.lpfnWndProc = WndProc; //    !
  WndClass.cbClsExtra = 0; WndClass.cbWndExtra = 0;
  WndClass.hInstance = hInstance; //  
  WndClass.hIcon   = LoadIcon(hInstance,"CLIENT_ICON"); // 
  WndClass.hCursor = LoadCursor(NULL,IDC_ARROW);  //  
  WndClass.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH); //  
  WndClass.lpszMenuName = "CLIENT_MENU"; //   
  WndClass.lpszClassName = szClassName; //   

  /*    */
  if (! RegisterClass(&WndClass) )
  { MessageBox(NULL,"Cannot register class","Server",MB_OK);
    return 1;
  }

  /*   */
  hWnd = CreateWindow(szClassName, //   
  							 szWindowTitle, //   ( )
                      WS_OVERLAPPEDWINDOW, //  
                       20,  20, // X,Y 
                      250, 250, // , 
                      NULL, //   
                      NULL, //   ( )
                      hInstance, //  
                      NULL); //    

 if (!hWnd)
 { MessageBox(NULL,"Cannot create Window","Client",MB_OK | MB_SYSTEMMODAL);
   return 2; //  ,     
 }

 ShowWindow(hWnd,SW_SHOWNORMAL); //  
 UpdateWindow(hWnd);

 /*       WM_QUIT */
 while (GetMessage(&Msg, //   
                   NULL, //  ,  NULL,     
                   0,0)) //   ( 0,0,  )
 {
  TranslateMessage(&Msg); //     
  DispatchMessage(&Msg);  //  
 }
 return Msg.wParam; //   ,   WM_QUIT
}


/*   */
LRESULT WINAPI WndProc( HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam )
{ BYTE szBuf[256];
  switch (Message)
  { case WM_CREATE  : //  DDEML    
      hConv=DDEClientOpen(hInst, (LPSTR) "BMPServer",
        (LPSTR) "BMPFile", (LPSTR) "DDEData");
      if (hConv==NULL) //    ,   
      { if (IDYES == MessageBox(hWnd,"  .\n?",
           szWindowTitle, MB_YESNO | MB_ICONQUESTION))
        {   if (WinExec("DDEMLSR",SW_SHOW)<32)
            { MessageBox(hWnd,"  ",szWindowTitle,
              MB_OK | MB_ICONHAND);
              return -1;
            }
            else //        
            { hConv=DDEClientOpen(hInst, (LPSTR) "BMPServer",
                   (LPSTR) "BMPFile", (LPSTR) "DDEData");
               if (hConv==NULL) return -1;
                         else return 0;
            }
         }
         else return -1;
      }
      return 0;


    case WM_COMMAND :
     switch LOWORD(wParam)
     { case CM_HELPABOUT:
         MessageBox(hWnd,"DDEML Client\n Version 1.0","About",
                    MB_OK | MB_ICONINFORMATION);
         break;
       case CM_FILEEXIT:
         DestroyWindow(hWnd);
         break;
       case CM_SEND_TO_SERV:
         if (!DDESend(hConv,(LPSTR)"picture.bmp"))
           MessageBox(hWnd,"  ",szWindowTitle,
             MB_OK | MB_ICONHAND);
         break;
       case CM_GET_FROM_SERV:
        if (DDEReceive(hConv,szBuf,80))
             MessageBox(hWnd,szBuf,szWindowTitle,MB_OK);
        else MessageBox(hWnd,"  ",szWindowTitle,
              MB_OK | MB_ICONHAND);
         break;
     }
     return 0;

    case WM_DESTROY :
      DDEClientClose(hConv);
      PostQuitMessage(0); //     WM_QUIT
   	return 0;           //   ,    0

    default :
     //      :
     return DefWindowProc(hWnd,Message,wParam,lParam);
  }
}
