#include <windows.h>
#include "ddemlfn.h"

//  
DWORD idInst = 0; //  ,  
                  //    DDEML
HSZ hszService = NULL;
HSZ hszTopic   = NULL;
HSZ hszItem    = NULL;
HCONV hConvApp = NULL; //  

char szDDEData[200] = ""; //    
char szDDEServerVersion[] = "DDEML Server 1.0";

HWND hwnd = NULL;

//  
HDDEDATA CALLBACK DDEServerCallback(WORD wType, WORD wFmt, HCONV hConv,
   HSZ hsz1, HSZ hsz2, HDDEDATA hData, DWORD dwData1, DWORD dwData2);

//  DDEServerOpen -   DDEML

bool DDEServerOpen(HINSTANCE hInst, HWND hWnd, LPSTR szService, LPSTR szTopic, LPSTR szItem)
{
  if (DdeInitialize(&idInst, //   
         (PFNCALLBACK)DDEServerCallback, //    
         APPCLASS_STANDARD, // 
         0L)) // 
      return false;
  else //  
  { //     ,    
   hwnd = hWnd;
   hszService = DdeCreateStringHandle(idInst,szService,CP_WINANSI);
   hszTopic   = DdeCreateStringHandle(idInst,szTopic,  CP_WINANSI);
   hszItem    = DdeCreateStringHandle(idInst,szItem,   CP_WINANSI);
   //  
   DdeNameService(idInst,hszService,(HSZ) NULL, DNS_REGISTER);
   return true;
  }
}


//  DDEServerClose -    DDEML
void DDEServerClose(void)
{
  if (hConvApp!=NULL)
  { DdeDisconnect(hConvApp);
    hConvApp = NULL;
  }
  //   
  DdeNameService(idInst,hszService,(HSZ)NULL,DNS_UNREGISTER);
  //   
  DdeFreeStringHandle(idInst, hszService);
  DdeFreeStringHandle(idInst, hszTopic);
  DdeFreeStringHandle(idInst, hszItem);
}

//
HDDEDATA CALLBACK DDEServerCallback(
   WORD wType,     //  
   WORD wFmt,      //  
   HCONV hConv,    //  
   HSZ hsz1,       //   
   HSZ hsz2,       //   
   HDDEDATA hData, //    
   DWORD dwData1,  //    
   DWORD dwData2) //    
{
 switch (wType)
 { case XTYP_CONNECT: //   
    //   ,     
    if (hsz2 == hszService) return ((HDDEDATA)true);
                     else   return ((HDDEDATA)false);
   case XTYP_REQUEST: //    
     hData = DdeCreateDataHandle(idInst,szDDEServerVersion,
               lstrlen(szDDEServerVersion)+1,0,hszItem,CF_TEXT,0);
     if (hData!=NULL)
       return (hData); //      
     else break;
   case XTYP_EXECUTE: //      
    break;
   case XTYP_POKE: //   
    if (hsz1 == hszTopic)
     { DdeGetData(hData,(LPBYTE) szDDEData,200,0); //  
       if (szDDEData != NULL)
       {PostMessage(hwnd,WM_COMMAND,CM_REPAINT,(LONG) szDDEData);
        return (HDDEDATA) DDE_FACK; //    
       }
     }
   else break;
  case XTYP_CONNECT_CONFIRM: //   
    hConvApp = hConv; //   
    break;
  case XTYP_DISCONNECT: //   
    hConvApp = NULL;
    break;
  case XTYP_ERROR: // 
    break;
 } // switch
 return (HDDEDATA) NULL;
}

