#include <windows.h>
#include "ddemlcf.h"

//  
DWORD idInst; //   DDEML
HSZ hszService = NULL;
HSZ hszTopic   = NULL;
HSZ hszItem    = NULL;

HDDEDATA hData;
DWORD dwResult;
WORD wFmt = CF_TEXT;

//  
HDDEDATA WINAPI DDEClientCallback(WORD wType, WORD wFmt, HCONV hConv,
   HSZ hsz1, HSZ hsz2, HDDEDATA hData, DWORD dwData1, DWORD dwData2);

//  DDEClientOpen -   DDEML

HCONV DDEClientOpen(HINSTANCE hInst, LPSTR szService, LPSTR szTopic, LPSTR szItem)
{ HCONV hConv = NULL;
  if (DdeInitialize(&idInst, //   
         (PFNCALLBACK)DDEClientCallback, //    
         APPCMD_CLIENTONLY, // 
         0L)) // 
      return NULL;
  else //  
  { //     ,    
   hszService = DdeCreateStringHandle(idInst,szService,CP_WINANSI);
   hszTopic   = DdeCreateStringHandle(idInst,szTopic,  CP_WINANSI);
   hszItem    = DdeCreateStringHandle(idInst,szItem,   CP_WINANSI);
   //
   hConv = DdeConnect(idInst,hszService,hszTopic,(PCONTEXT) NULL);
   return hConv; //     
  }
}

//  DDEClientClose -    DDEML
void DDEClientClose(HCONV hConv)
{
  if (hConv!=NULL) //   
  { DdeDisconnect(hConv);
    hConv = NULL;
  }
  //   
  DdeFreeStringHandle(idInst, hszService);
  DdeFreeStringHandle(idInst, hszTopic);
  DdeFreeStringHandle(idInst, hszItem);
}

//  DDESend -    
bool DDESend(HCONV hConv, LPSTR szString)
{
 if (hConv)
 { //   
   hData = DdeCreateDataHandle(idInst, szString,lstrlen(szString)+1,0,hszItem,CF_TEXT,0);
   //    
   if (hData)
    hData = DdeClientTransaction(
        (LPBYTE)hData, //  ,  
        -1, //    -1    HDDEDATA
        hConv, //  
        hszItem, //   
        CF_TEXT, //  
        XTYP_POKE, //  
        1000, //   
        &dwResult);//    ,      
   if (hData) return true;
         else return false;
 }
 else return false;
}

//  DDEReceive -     
bool DDEReceive(HCONV hConv, LPSTR szBuf, int nBufSize)
{
 //    
 if (hConv)
 { hData = DdeClientTransaction(NULL,0,hConv,hszItem,CF_TEXT,XTYP_REQUEST,1000,&dwResult);
   if (hData) //    
   { DdeGetData(hData,szBuf,nBufSize,0);
     return true;
   }
   else return false;
 }
 else return false;
}

HDDEDATA WINAPI DDEClientCallback(
   WORD wType,     //  
   WORD wFmt,      //  
   HCONV hConv,    //  
   HSZ hsz1,       //   
   HSZ hsz2,       //   
   HDDEDATA hData, //    
   DWORD dwData1,  //    
   DWORD dwData2) //    
{
 switch (wType)
 {
  case XTYP_DISCONNECT: //   
    return (HDDEDATA) NULL;
  case XTYP_ERROR: // 
    break;
  case XTYP_XACT_COMPLETE: // 
    break;
 } // switch
 return (HDDEDATA) NULL;
}

